//
//  SineViewController.m
//  hw1
//
//  Created by Uri Nieto on 1/10/10.
//  Copyright 2010 Stanford University. All rights reserved.
//

#import "SineViewController.h"
#import "mo_audio.h"
#import "mo_accel.h"
#import "mo_touch.h"

#define SRATE 44100
#define FRAMESIZE 128
#define NUMCHANNELS 2

double g_fc = 440.0;
double g_fc_target = 440.0;
double g_fc_slew = 0.01;


// implement audio callback here
void audioCallback( Float32 * buffer, UInt32 frameSize, void * userData) {
  
  static float phase = g_fc / (SRATE*1.0);
  
  for (int i=0; i<frameSize; i++) {
    buffer[2*i] = buffer[2*i + 1] = sin(2.0*M_PI*phase);
    //g_fc = (g_fc_target - g_fc)*g_fc_slew + g_fc;
    phase += g_fc/(SRATE*1.0);
    
    if (phase > 1.0f)
      phase -= 1.0f;
  }
  
}

void accelCallback( double x, double y, double z, void * data) {
  //NSLog([NSString stringWithFormat: @"x: %f, y: %f, z: %f", x,y,z]);
  
  g_fc = 440 + 50.0*x;
  
}

@implementation SineViewController

/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/


// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
  [super viewDidLoad];
  
  // Init Audio
  bool result = MoAudio::init( SRATE, FRAMESIZE, NUMCHANNELS );
  
  if (!result) {
    NSLog(@"cannot initialize real-time audio!");
    return;
  }
  
  // start audio layer
  result = MoAudio::start( audioCallback, NULL);
  
  if (!result) {
    NSLog(@"cannot start real-time audio!");
    return;
  }
  
  // Init Accel
  MoAccel::instance()->addCallback( accelCallback, NULL );
}


- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
    [super dealloc];
}


@end
