/******************************************/
/*
 voice.h
 by Uri Nieto, 2009
 
 Homework #2: Delay, Feedback, Moving Average, and Polyphony
 
 Music 256a
 Stanford University
 */
/******************************************/

#ifndef __VOICE_H__
#define __VOICE_H__

#define SAMPLE Float32           
#define MAX_DELAY 2000000        //Buffer size of our delay buffer
#define MY_PIE 3.14159265358979
#define MY_SRATE 44100          //Sample rate of our signal

class Voice  {
public:
  Voice(int delayLen, SAMPLE delayFactor, bool midi);
  void synthesize(SAMPLE * obuffy, 
                  SAMPLE * ibuffy, 
                  long nBufferFrames);
  void initDelayBuffer();
  void setNoise(bool noise);
  void setDelayLen(long delayLen);
  void setDelayFactor(double delayFactor);
  void pluck(long delayLen);
  
protected:
  int m_writer;               //Pointer to write to the delay buffer
  int m_reader;               //Pointer to read from the delay buffer
  SAMPLE m_delay[2*MAX_DELAY];  //Delay buffer of max MAX_DELAY
  SAMPLE m_delayFactor;       //Decay factor of our delay
  long m_delayLen;            //Length of our delay
  SAMPLE m_prev;              //Previous frame
  bool m_noise;               //Whether there's noise in the buffer
  bool m_midiInput;           //Whether we are using midi input
  int m_t;                    //Time
  long m_pluck;               //Pluck processed at the moment
  
};

#endif